/*-
 * ~~~~~~licensing~~~~~~
 * entaxy-management-plugin
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
var Entaxy;
(function (Entaxy) {
    Entaxy._module
        .directive('draggable', function() {
            return function(scope, element) {
                let el = element[0];

                el.draggable = true;

                el.addEventListener(
                    'dragstart',
                    function(e) {
                        e.dataTransfer.effectAllowed = 'move';
                        e.dataTransfer.setData("text/html", e.target.id);
                        this.classList.add('drag');
                        return false;
                    },
                    false
                );

                el.addEventListener(
                    'dragend',
                    function(e) {
                        this.classList.remove('drag');
                        return false;
                    },
                    false
                );
            }
        })
        .directive('droppable', ['$parse', function ($parse) {
            return {
                restrict: 'A',
                link: function (scope, element, attrs) {
                    element[0].addEventListener('drop', scope.handleDrop, false);
                    element[0].addEventListener('dragover', scope.handleDragOver, false);
                    scope.handleDropFn = $parse(attrs.handleDropFn);
                },
                controller: ['$scope', function($scope) {
                    $scope.handleDrop = function (e) {
                        e.preventDefault();
                        e.stopPropagation();

                        if ($scope.handleDropFn) {
                            let droppedElementId = e.dataTransfer.getData("text/html");
                            $scope.droppedElementId = droppedElementId;
                            $scope.handleDropFn($scope);
                        }
                    };

                    $scope.handleDragOver = function (e) {
                        e.preventDefault();
                        return;
                    };
                }]
            };
        }])
        .name;

})(Entaxy || (Entaxy = {}));
